'use strict';
Object.defineProperty(exports, '__esModule', {
  value: true
});
// istanbul ignore next

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

// istanbul ignore next

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

// istanbul ignore next

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

// istanbul ignore next

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

// istanbul ignore next

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _yeomanGenerator = require('yeoman-generator');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _packageJson = require('../../package.json');

var _packageJson2 = _interopRequireDefault(_packageJson);

var _recursiveReaddir = require('recursive-readdir');

var _recursiveReaddir2 = _interopRequireDefault(_recursiveReaddir);

var _updateNotifier = require('update-notifier');

var _updateNotifier2 = _interopRequireDefault(_updateNotifier);

var _utils = require('../utils');

var _utils2 = _interopRequireDefault(_utils);

var GenBase = (function (_Base) {
  function GenBase() {
    _classCallCheck(this, GenBase);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _get(Object.getPrototypeOf(GenBase.prototype), 'constructor', this).apply(this, args);
    this.name = args['0'][0];
  }

  _inherits(GenBase, _Base);

  _createClass(GenBase, [{
    key: 'askForModuleName',
    value: function askForModuleName(params) {
      // istanbul ignore next

      var _this = this;

      var done = this.async(),
          notifier = (0, _updateNotifier2['default'])({
        packageName: _packageJson2['default'].name,
        packageVersion: _packageJson2['default'].version
      });

      // notifiy user about update, if there is an update
      notifier.notify();

      this.prompt([{
        type: 'list',
        name: 'module',
        store: true,
        message: 'Which module is this for?',
        'default': this.config.get('lastUsedModule'),
        when: function when() {
          return !(_this.options && _this.options.module);
        },
        choices: function choices() {
          // console.log(this.config);
          var moduleDone = this.async();

          (0, _recursiveReaddir2['default'])(_utils2['default'].getAppDir(), function (err, files) {
            if (err) {
              throw err;
            }
            moduleDone(_utils2['default'].moduleFilter(files));
          });
        }
      }, {
        name: 'url',
        message: 'What\'s the URL for this route?',
        'default': function _default() {
          // if child state return child portion as url
          if (_this.name.indexOf('.') > -1) {
            return '/' + _utils2['default'].hyphenName(_this.name.split('.')[1]);
          }
          return '/' + _utils2['default'].hyphenName(_this.name);
        },
        when: function when() {
          return params && params.url && !_this.config.get('ngRoute') && !(_this.options && _this.options.url);
        }
      }, {
        name: 'templateUrl',
        message: 'What\'s the templateURL for this route?',
        'default': function _default(answers) {
          var module = answers.module || _this.options.module;

          return _utils2['default'].normalizeModulePath(module) + '/' + (_this.options.structure === 'module-type' || _this.config.get('structure') === 'module-type' ? 'views/' : '') + _utils2['default'].hyphenName(_this.name.replace('.', '-')) + '.tpl.html';
        },
        when: function when() {
          return params && params.templateUrl && !(_this.options && _this.options['template-url']);
        }
      }], function (props) {
        _this.module = props.module || _this.options.module;
        _this.url = props.url || _this.options.url || _this.name;
        _this.templateUrl = props.templateUrl || _this.options['template-url'];

        // if moduleName ends with a slash remove it
        if (_this.module.charAt(_this.module.length - 1) === '/' || _this.module.charAt(_this.module.length - 1) === '\\') {
          _this.module = _this.module.slice(0, _this.module.length - 1);
        }

        // prepend slash if missing
        if (_this.url && (_this.url.charAt(0) !== '/' && _this.url.charAt(0) !== '\\')) {
          _this.url = '/' + _this.url;
        }

        // convert backslashes to forwardslashes for Windows
        if (_this.templateUrl) {
          _this.templateUrl = _this.templateUrl.replace('\\', '/');
        }

        // append .tpl.html if not existing
        if (!/[.]tpl[.]html$/.test(_this.templateUrl)) {
          _this.templateUrl = _this.templateUrl + '.tpl.html';
        }

        done();
      });
    }
  }, {
    key: 'getConfig',
    value: function getConfig() {
      var config = undefined,
          modules = undefined;

      config = {
        name: this.name,
        markup: this.options.markup || this.config.get('markup'),
        appScript: this.options['app-script'] || this.config.get('appScript'),

        structure: this.options.structure || this.config.get('structure'),
        controllerAs: this.options['controller-as'] !== undefined && this.options['controller-as'] !== null ? this.options['controller-as'] : this.config.get('controllerAs'),

        directiveTemplateUrl: this.options['directive-template-url'] !== undefined && this.options['directive-template-url'] !== null ? this.options['directive-template-url'] : this.config.get('directiveTemplateUrl'),

        skipController: this.options['skip-controller'] !== undefined && this.options['skip-controller'] !== null ? this.options['skip-controller'] : this.config.get('skipController'),

        testScript: this.options['test-script'] || this.config.get('testScript'),
        testFramework: this.config.get('testFramework'),
        e2eTestFramework: this.config.get('e2eTestFramework'),
        style: this.options.style || this.config.get('style'),
        ngRoute: this.options['ng-route'] !== undefined && this.options['ng-route'] !== null ? this.options['ng-route'] : this.config.get('ngRoute'),

        appName: _utils2['default'].getAppName(this.config.path),
        appDir: _utils2['default'].getAppDir(this.config.path),
        testDir: _utils2['default'].getUnitTestDir(this.config.path),
        ctrlName: _utils2['default'].ctrlName(this.name),
        humanName: _utils2['default'].humanName(this.name),
        hyphenName: _utils2['default'].hyphenName(this.name),
        lowerCamel: _utils2['default'].lowerCamel(this.name),
        upperCamel: _utils2['default'].upperCamel(this.name)
      };

      // only run for Angular components
      if (this.module) {
        modules = _utils2['default'].extractModuleNames(this.module);
        config.modulePath = _utils2['default'].normalizeModulePath(this.module);
        config.moduleName = _utils2['default'].lowerCamel(modules[0]);
        config.parentModuleName = _utils2['default'].lowerCamel(modules[1]);

        // create reference path to typings/tsd.d.ts from generated file
        if (config.appScript === 'ts') {
          // relative path between module path
          config.referencePath = _path2['default'].relative(config.modulePath, _path2['default'].dirname(this.config.path));
          // replace Windows path separators with Unix
          config.referencePath = config.referencePath.replace('\\', '/');
          config.referencePath = '../' + config.referencePath + '/typings/tsd.d.ts';
          // if module/type structure we need to go up one more folder
          if (config.structure === 'module-type' && !this.isModule) {
            config.referencePath = '../' + config.referencePath;
          }
        }
      }

      return config;
    }
  }, {
    key: 'copyFile',
    value: function copyFile(type, component, dest, context) {
      var pluralComponent = component === 'factory' ? 'factories' : component + 's',
          fileName = undefined,
          src = undefined;

      if (typeof dest === 'object') {
        context = dest;
        dest = null;
      }
      context = context || this.getConfig();
      if (!dest) {
        // test or app directory?
        dest = type === 'unit' ? context.testDir : context.appDir;
        // append module path and type (if using module-type)
        dest = _path2['default'].join(dest, context.modulePath, component !== 'module' && context.structure === 'module-type' ? pluralComponent : '');

        // create file name
        fileName = context.hyphenName + '-' + component;
        if (type === 'markup') {
          fileName += '.tpl.' + context.markup;
        }
        if (type === 'src') {
          fileName += '.' + context.appScript;
        }
        if (type === 'unit') {
          fileName += '_test.' + context.testScript;
        }
        // style types ALWAYS send a dest

        // append file name to dest
        dest = _path2['default'].join(dest, fileName);
      }

      if (type === 'markup') {
        src = '_' + component + '.' + context.markup;
      }
      if (type === 'src') {
        src = '_' + component + '.' + context.appScript;
      }
      if (type === 'style') {
        src = component + '.' + context.style;
      }
      if (type === 'unit') {
        src = '_spec.' + context.testScript;
      }

      this.copySimpleFile(src, dest, context);
    }
  }, {
    key: 'copySimpleFile',
    value: function copySimpleFile(src, dest, context) {
      context = context || this.context;
      // remove underscore from templated file names
      dest = dest || src.replace(/_/g, '');

      this.fs.copyTpl(this.templatePath(src), this.destinationPath(dest), context);
    }
  }, {
    key: 'copyMarkupFile',
    value: function copyMarkupFile(component, dest, context) {
      return this.copyFile('markup', component, dest, context);
    }
  }, {
    key: 'copySrcFile',
    value: function copySrcFile(component, dest, context) {
      return this.copyFile('src', component, dest, context);
    }
  }, {
    key: 'copyStyleFile',
    value: function copyStyleFile(component, dest, context) {
      return this.copyFile('style', component, dest, context);
    }
  }, {
    key: 'copyUnitTest',
    value: function copyUnitTest(component, dest, context) {
      return this.copyFile('unit', component, dest, context);
    }
  }, {
    key: 'copyE2e',
    value: function copyE2e(context) {
      var testScript = context.testScript === 'ts' ? 'js' : context.testScript,
          e2eFile = _path2['default'].join('e2e', context.hyphenName, context.hyphenName);

      this.copySimpleFile('page.po.' + testScript, e2eFile + '.po.' + testScript, context);
      this.copySimpleFile('page_test.' + testScript, e2eFile + '_test.' + testScript, context);
    }
  }]);

  return GenBase;
})(_yeomanGenerator.Base);

exports['default'] = GenBase;
module.exports = exports['default'];