'use strict';
Object.defineProperty(exports, '__esModule', {
  value: true
});
// istanbul ignore next

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

// istanbul ignore next

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

// istanbul ignore next

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

// istanbul ignore next

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

// istanbul ignore next

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _genBase = require('../genBase');

var _genBase2 = _interopRequireDefault(_genBase);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _ngAddDep = require('ng-add-dep');

var _ngAddDep2 = _interopRequireDefault(_ngAddDep);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _utils = require('../utils');

var _utils2 = _interopRequireDefault(_utils);

var Generator = (function (_GenBase) {
  function Generator() {
    _classCallCheck(this, Generator);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _get(Object.getPrototypeOf(Generator.prototype), 'constructor', this).apply(this, args);
  }

  _inherits(Generator, _GenBase);

  _createClass(Generator, [{
    key: 'initialize',
    get: function get() {
      return function () {
        this.module = this.name;

        // used by genBase to know this is not a normal component for module-type structures
        // used for creating TypeScript reference path
        this.isModule = true;

        // if moduleName ends with a slash remove it
        if (this.module.charAt(this.module.length - 1) === '/' || this.module.charAt(this.module.length - 1) === '\\') {
          this.module = this.module.slice(0, this.module.length - 1);
        }
      };
    }
  }, {
    key: 'writing',
    get: function get() {
      return function () {
        var filePath = undefined,
            filePathToCheck = undefined,
            depName = undefined,
            parentDir = undefined,
            parentModuleName = undefined,
            moduleDest = undefined;

        this.context = this.getConfig();

        // extrac the new module name (last part of path)
        this.context.moduleName = _path2['default'].basename(this.module);

        // modify context because these were all performed on the ENTIRE module path
        // instead of just the new module's name
        this.context.lowerCamel = _utils2['default'].lowerCamel(this.context.moduleName);
        this.context.hyphenModule = _utils2['default'].hyphenName(this.context.moduleName);
        this.context.upperModule = _utils2['default'].upperCamel(this.context.moduleName);
        this.context.templateUrl = _path2['default'].join(this.module).replace(/\\/g, '/');
        this.context.modulePath = _utils2['default'].normalizeModulePath(this.module);

        // create new module directory
        _mkdirp2['default'].sync(_path2['default'].join(this.context.appDir, this.context.modulePath));

        // check if path and moduleName are the same
        // if yes - get root app.js file to prepare adding dep
        // else - get parent module file to prepare adding dep
        if (this.context.moduleName === this.module) {
          filePathToCheck = _path2['default'].join(this.context.appDir, 'app');
        } else {
          // go up one driectory from new module's path to retrieve parent's directory
          parentDir = _path2['default'].join(this.context.appDir, this.context.modulePath, '..');
          // get parent module's name
          parentModuleName = _path2['default'].basename(parentDir);

          filePathToCheck = _path2['default'].join(this.context.appDir, this.context.modulePath, '..', parentModuleName);
        }

        // get module path
        filePath = _utils2['default'].findModuleFile(filePathToCheck);

        // if adding dep to app file, then dep is `module
        // else dep is `parent.module`
        depName = (this.context.parentModuleName ? this.context.parentModuleName + '.' : '') + this.context.lowerCamel;
        // add dep and save modifications
        _fs2['default'].writeFileSync(filePath, (0, _ngAddDep2['default'])(_fs2['default'].readFileSync(filePath, 'utf8'), depName));

        // create new module
        moduleDest = _path2['default'].join(this.context.appDir, this.context.modulePath, this.context.hyphenModule);
        this.copySrcFile('module', moduleDest + '-module.' + this.context.appScript, this.context);
        if (this.options && !this.options.empty) {
          this.copySrcFile('module-routes', moduleDest + '-routes.' + this.context.appScript, this.context);
        }
      };
    }
  }, {
    key: 'end',
    get: function get() {
      return function () {
        if (this.options && !this.options.empty) {
          this.composeWith('ng-poly:route', {
            args: [_utils2['default'].lowerCamel(this.module.split(/[\/\\]/).pop())],
            options: {
              module: this.module,
              url: '/' + this.context.hyphenModule,
              'template-url': this.context.modulePath + '/' + ('' + (this.context.structure === 'module-type' ? 'views/' : '') + this.context.hyphenModule + '.tpl.html'),

              markup: this.options.markup,
              'app-script': this.options['app-script'],
              'controller-as': this.options['controller-as'],
              'pass-func': this.options['pass-func'],
              'named-func': this.options['named-func'],
              'test-script': this.options['test-script'],
              'test-dir': this.options['test-dir'],
              'ng-route': this.options['ng-route'],
              style: this.options.style
            }
          }, {
            local: require.resolve('../route'),
            link: 'strong'
          });
        }
      };
    }
  }]);

  return Generator;
})(_genBase2['default']);

exports['default'] = Generator;
module.exports = exports['default'];