'use strict';
Object.defineProperty(exports, '__esModule', {
  value: true
});
// istanbul ignore next

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

// istanbul ignore next

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

// istanbul ignore next

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

// istanbul ignore next

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

// istanbul ignore next

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _genBase = require('../genBase');

var _genBase2 = _interopRequireDefault(_genBase);

var _ngAddDep = require('ng-add-dep');

var _ngAddDep2 = _interopRequireDefault(_ngAddDep);

var _utils = require('../utils');

var _utils2 = _interopRequireDefault(_utils);

var Generator = (function (_GenBase) {
  function Generator() {
    _classCallCheck(this, Generator);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _get(Object.getPrototypeOf(Generator.prototype), 'constructor', this).apply(this, args);
  }

  _inherits(Generator, _GenBase);

  _createClass(Generator, [{
    key: 'prompting',
    get: function get() {
      return function () {
        this.askForModuleName({ url: true, templateUrl: true });

        // convert backslashes to forwardslashes for Windows
        if (this.templateUrl) {
          this.templateUrl = this.templateUrl.replace('\\', '/');
        }
      };
    }
  }, {
    key: 'writing',
    get: function get() {
      return function () {
        var config = this.getConfig(),
            dependency = config.ngRoute ? 'ngRoute' : 'ui.router'
        // save modifications
        ,
            newRouteConfig
        // module file to add dep to
        = undefined,
            modulePath = undefined,
            moduleFile
        // route file to add route to
        = undefined,
            routesPath = undefined,
            routesFile = undefined,
            wipPath = undefined,
            newState = undefined;

        newRouteConfig = {
          appScript: config.appScript,
          controllerAs: config.controllerAs,
          skipController: config.skipController,
          passFunc: config.passFunc,
          ngRoute: config.ngRoute
        };

        // move this logic to utils-route
        config.url = this.url;
        config.lowerCamel = _utils2['default'].lowerCamel(this.name.replace('.', '-'));
        config.hyphenName = _utils2['default'].hyphenName(this.name.replace('.', '-'));
        config.ctrlName = _utils2['default'].ctrlName(this.name.replace('.', '-'));
        config.humanName = _utils2['default'].humanName(this.name.replace('.', '-'));

        newState = {
          name: this.name,
          module: this.module,
          url: this.url,
          lowerCamel: config.lowerCamel,
          hyphenName: config.hyphenName,
          ctrlName: config.ctrlName,
          templateUrl: this.templateUrl
        };

        // create module path minus extension
        // if modulePath is empty file name is app
        wipPath = _path2['default'].join(this.config.path, '..', config.appDir, config.modulePath, config.modulePath === '' ? 'app' : _utils2['default'].hyphenName(config.moduleName));
        // get name-module.{coffee,js,ts}
        modulePath = _utils2['default'].findModuleFile(wipPath);
        moduleFile = _fs2['default'].readFileSync(modulePath, 'utf8');
        // if file doesn't have the dependency, add it
        _fs2['default'].writeFileSync(modulePath, (0, _ngAddDep2['default'])(moduleFile, dependency));

        // get name-routes.{coffee,js,ts}
        routesPath = _utils2['default'].findRoutesFile(wipPath);
        routesFile = _fs2['default'].readFileSync(routesPath, 'utf8');
        // add route to route file
        _fs2['default'].writeFileSync(routesPath, _utils2['default'].addRoute(routesFile, newState, newRouteConfig));

        this.copyE2e(config);

        if (!config.skipController) {
          // call controller subgenerator
          this.composeWith('ng-poly:controller', {
            args: [this.name.replace('.', '-')],
            options: {
              module: this.module,
              structure: this.options.structure,
              markup: this.options.markup,
              'app-script': this.options['app-script'],
              'controller-as': this.options['controller-as'],
              classes: this.options.classes,
              'pass-func': this.options['pass-func'],
              'named-func': this.options['named-func'],
              'test-script': this.options['test-script'],
              'test-dir': this.options['test-dir'],
              style: this.options.style
            }
          }, {
            local: require.resolve('../controller'),
            link: 'strong'
          });
        }

        // call view subgenerator
        this.composeWith('ng-poly:view', {
          args: [_path2['default'].basename(this.templateUrl)],
          options: {
            module: this.module,
            structure: this.options.structure,
            markup: this.options.markup,
            'app-script': this.options['app-script'],
            'controller-as': this.options['controller-as'],
            'pass-func': this.options['pass-func'],
            'named-func': this.options['named-func'],
            'test-script': this.options['test-script'],
            'test-dir': this.options['test-dir'],
            'ng-route': this.options['ng-route'],
            style: this.options.style
          }
        }, {
          local: require.resolve('../view'),
          link: 'strong'
        });
      };
    }
  }]);

  return Generator;
})(_genBase2['default']);

exports['default'] = Generator;
module.exports = exports['default'];