'use strict';
// istanbul ignore next

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _underscoreString = require('underscore.string');

var _underscoreString2 = _interopRequireDefault(_underscoreString);

/**
 * Returns lower camel case
 * @param {String} name - name to convert
 * @return {String} - converted name
 */
exports.lowerCamel = function lowerCamel(name) {
  return _underscoreString2['default'].camelize(_underscoreString2['default'].slugify(_underscoreString2['default'].humanize(name)));
};

/**
 * Returns upper camel case
 * @param {String} name - name to convert
 * @return {String} - converted name
 */
exports.upperCamel = function upperCamel(name) {
  return _underscoreString2['default'].classify(_underscoreString2['default'].slugify(_underscoreString2['default'].humanize(name)));
};

/**
 * Returns human readable form
 * @param {String} name - name to convert
 * @return {String} - converted name
 */
exports.humanName = function humanName(name) {
  return _underscoreString2['default'].humanize(name);
};

/**
 * Returns hyphenated name
 * @param {String} name - name to convert
 * @return {String} - converted name
 */
exports.hyphenName = function hyphenName(name) {
  return _underscoreString2['default'].slugify(_underscoreString2['default'].humanize(name));
};

/**
 * Returns controller name
 * @param {String} name - name to convert
 * @return {String} - converted name
 */
exports.ctrlName = function ctrlName(name) {
  return exports.upperCamel(name) + 'Ctrl';
};